import java.util.*;


/**
 * EX5: Invertire una lista semplicemente concatenata
 */


public class EX5 {


 public static LinkedList reverseRec(LinkedList l)  //procedura ricorsiva
  {
   if (! l.isEmpty())
    {
     Object n = l.deleteHead();
     reverseRec(l).insertTail(n);
    }
   return l;
  }



/** procedura iterativa che usa una sola scansione attraverso la lista **/

    public static void oldreverse(LinkedList l1)
    {
      int cont=0;
      if (l1.isEmpty()) return;  
      ListNode pl1=l1.getHead().getNext();
      ListNode aux1=null;
       for(; pl1!=null; pl1=pl1.getNext()){
           aux1=l1.deleteKey(pl1.getInfo()); // si pu fare direttamente...
           l1.insertHead(aux1.getInfo());
           
           }
        }

    public static LinkedList reverse(LinkedList l)
    {
      int cont=0;
      LinkedList lrev=new LinkedList();	
      if (l.isEmpty()) return l;  
      while (! l.isEmpty()) {
	lrev.insertHead(l.deleteHead());
      }
      return lrev;
    }



  public static void main (String[ ] args) {
     new EX5().run();
  } // method main

  public void run(){

     	/**** GENERAZIONE LISTA RANDOM ****/	
     	final int SEED = 111; // seme della sequenza
     	// Random r = new Random (SEED);
     	Random r = new Random ();

     	LinkedList  randList1;
	randList1 = new LinkedList( );
     	for (int i = 0; i < 10; i++)
             randList1.insertHead (new MyInteger(r.nextInt(100)));
	System.out.println("Lista da invertire:");
        randList1.printList( );

	//randList1 = reverseRec(randList1);
	randList1 = reverse(randList1);
	System.out.println("Lista in ordine inverso:");
        randList1.printList( );

     
 } // method run

} // class EX5
